var CodeSuggestionCache = /** @class */ (function () {
    function CodeSuggestionCache(xsdParser) {
        var _this = this;
        this.elements = function (parentElement) {
            return parentElement === undefined ? _this.rootElements() : _this.subElements(parentElement);
        };
        this.attributes = function (element) {
            var attributes = _this.attributeCollections.get(element);
            if (attributes)
                return attributes;
            return _this.getAttributes(element);
        };
        this.rootElements = function () {
            var elements = _this.elementCollections.get('rootElements');
            if (elements)
                return elements;
            return _this.getRootElements();
        };
        this.getRootElements = function () {
            return _this.setElementCollection('rootElements', _this.xsdParser.getRootElements());
        };
        this.setElementCollection = function (element, documentElement) {
            _this.elementCollections.set(element, documentElement);
            return documentElement;
        };
        this.subElements = function (parentElement) {
            var subElements = _this.elementCollections.get(parentElement);
            if (subElements)
                return subElements;
            return _this.getSubElements(parentElement);
        };
        this.getSubElements = function (parentElement) {
            return _this.setElementCollection(parentElement, _this.xsdParser.getSubElements(parentElement));
        };
        this.getAttributes = function (element) {
            return _this.setAttributeCollection(element, _this.xsdParser.getAttributesForElement(element));
        };
        this.setAttributeCollection = function (element, documentAttribute) {
            _this.attributeCollections.set(element, documentAttribute);
            return documentAttribute;
        };
        this.xsdParser = xsdParser;
        this.elementCollections = new Map();
        this.attributeCollections = new Map();
    }
    return CodeSuggestionCache;
}());
export default CodeSuggestionCache;
//# sourceMappingURL=CodeSuggestionCache.js.map