var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { SimpleParser } from './SimpleParser';
import { DOMParser } from 'xmldom';
import { XsdNamespaces } from './XsdNamespaces';
var xsdGenerateTemplate = /** @class */ (function () {
    function xsdGenerateTemplate(xsdManager) {
        var _this = this;
        this.getTemplate = function (model, level, withAttributes) {
            var xml = model ? SimpleParser.getFullText(model) : undefined;
            if (xml) {
                var parsedXml = _this.domParser.parseFromString(xml);
                var xsdNamespaces = XsdNamespaces.getXsdNamespaces(xml);
                var xsdWorkers = XsdNamespaces.getXsdWorkersForNamespace(xsdNamespaces, _this.xsdManager);
                var documentElementName = parsedXml.documentElement.nodeName;
                var _a = __read(SimpleParser.splitNamespaceAndTag(documentElementName), 2), documentElementNamespace = _a[0], documentElementTag = _a[1];
                var element = [{ name: documentElementTag }];
                var elements = _this.getFirstSubElements(element, xsdWorkers, level, withAttributes);
                var newXml = _this.appendChildsToElement(elements[0]['elements'], parsedXml.documentElement, parsedXml, documentElementNamespace);
                return newXml.toString();
            }
        };
        this.getFirstSubElements = function (elements, xsdWorkers, levels, withAttributes) {
            elements.forEach(function (element) {
                xsdWorkers.forEach(function (xsdWorker) {
                    var subElements = xsdWorker.getFirstSubElements(element.name, withAttributes);
                    if (subElements.length > 0) {
                        if (--levels > 0) {
                            subElements = _this.getFirstSubElements(subElements, [xsdWorker], levels, withAttributes);
                        }
                        element['elements'] = subElements;
                    }
                });
            });
            return elements;
        };
        this.appendChildsToElement = function (childs, element, document, documentNamespace) {
            childs.forEach(function (child) {
                var node = document.createElement(documentNamespace ? documentNamespace + ":" + child.name : child.name);
                if (child['requiredAttribute'])
                    child['requiredAttribute'].map(function (requiredAttribute) {
                        return node.setAttribute(requiredAttribute.name, '');
                    });
                node.appendChild(document.createTextNode(''));
                if (child['elements']) {
                    node.appendChild(document.createTextNode('\n'));
                    node = _this.appendChildsToElement(child['elements'], node, document, documentNamespace);
                }
                element.appendChild(node);
                element.appendChild(document.createTextNode('\n'));
            });
            return element;
        };
        this.xsdManager = xsdManager;
        this.domParser = new DOMParser();
    }
    return xsdGenerateTemplate;
}());
export default xsdGenerateTemplate;
//# sourceMappingURL=XsdGenerateTemplate.js.map