import CodeSuggester from './CodeSuggester';
import { CompletionType } from './types';
import XsdParser from './XsdParser';
var XsdWorker = /** @class */ (function () {
    function XsdWorker(xsd) {
        var _this = this;
        this.withNamespace = function (namespace) {
            _this.namespace = namespace;
            return _this;
        };
        this.doCompletion = function (completionType, parentTag) {
            switch (completionType) {
                case CompletionType.snippet:
                    return _this.codeSuggester.elements(parentTag, _this.namespace, true);
                case CompletionType.element:
                    return _this.codeSuggester.elements(parentTag, _this.namespace);
                case CompletionType.attribute:
                    return _this.codeSuggester.attributes(parentTag);
                case CompletionType.incompleteElement:
                    return _this.codeSuggester.elements(parentTag, _this.namespace, false, true);
                case CompletionType.incompleteAttribute:
                    return _this.codeSuggester.attributes(parentTag, true);
            }
            return [];
        };
        this.getFirstSubElements = function (parentTag, withAttributes) {
            return _this.xsdParser.getFirstSubElements(parentTag, withAttributes);
        };
        this.xsd = xsd;
        this.xsdParser = new XsdParser(this.xsd);
        this.codeSuggester = new CodeSuggester(this.xsdParser);
    }
    return XsdWorker;
}());
export { XsdWorker };
//# sourceMappingURL=XsdWorker.js.map