export var CompletionType;
(function (CompletionType) {
    CompletionType[CompletionType["none"] = 0] = "none";
    CompletionType[CompletionType["element"] = 1] = "element";
    CompletionType[CompletionType["attribute"] = 2] = "attribute";
    CompletionType[CompletionType["incompleteElement"] = 3] = "incompleteElement";
    CompletionType[CompletionType["closingElement"] = 4] = "closingElement";
    CompletionType[CompletionType["snippet"] = 5] = "snippet";
    CompletionType[CompletionType["incompleteAttribute"] = 6] = "incompleteAttribute";
})(CompletionType || (CompletionType = {}));
var XmlDomError = /** @class */ (function () {
    function XmlDomError(message, type) {
        this.message = message;
        this.type = type;
    }
    Object.defineProperty(XmlDomError.prototype, "errorTypeString", {
        get: function () {
            switch (this.type) {
                case ErrorType.warning:
                    return '**Warning**';
                case ErrorType.error:
                    return '**Error**';
                case ErrorType.fetalError:
                    return '**Fatal error**';
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XmlDomError.prototype, "classNames", {
        get: function () {
            switch (this.type) {
                case ErrorType.warning:
                    return 'xml-lint xml-lint--warning';
                case ErrorType.error:
                    return 'xml-lint xml-lint--error';
                case ErrorType.fetalError:
                    return 'xml-lint xml-lint--fetal';
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XmlDomError.prototype, "errorMessage", {
        get: function () {
            var _a;
            return (_a = this.message.split(/[\t\n]/g)[1]) !== null && _a !== void 0 ? _a : this.message;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XmlDomError.prototype, "position", {
        get: function () {
            var columnMatch = this.message.match(/(?<=col:)[0-9]+/g);
            var lineNumberMatch = this.message.match(/(?<=line:)[0-9]+/g);
            var column = parseInt((columnMatch !== null && columnMatch !== void 0 ? columnMatch : 0)[0]) + 1;
            var lineNumber = parseInt((lineNumberMatch !== null && lineNumberMatch !== void 0 ? lineNumberMatch : 0)[0]);
            return { column: column, lineNumber: lineNumber };
        },
        enumerable: false,
        configurable: true
    });
    return XmlDomError;
}());
export { XmlDomError };
export var ErrorType;
(function (ErrorType) {
    ErrorType[ErrorType["warning"] = 0] = "warning";
    ErrorType[ErrorType["error"] = 1] = "error";
    ErrorType[ErrorType["fetalError"] = 2] = "fetalError";
})(ErrorType || (ErrorType = {}));
//# sourceMappingURL=types.js.map