"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var XsdWorker_1 = require("./XsdWorker");
var SimpleParser_1 = require("./SimpleParser");
var XsdManager = /** @class */ (function () {
    function XsdManager(editor) {
        var _this = this;
        this.set = function (xsd) {
            _this.xsdWorkers.set(xsd.path, new XsdWorker_1.XsdWorker(xsd));
        };
        this.update = function (xsd) {
            _this.delete(xsd.path);
            _this.set(xsd);
        };
        this.delete = function (path) {
            // this.xsdWorkers.get(path)?.dispose()
            return _this.xsdWorkers.delete(path);
        };
        this.get = function (path) { return _this.xsdWorkers.get(path); };
        this.has = function (path) { return _this.xsdWorkers.has(path); };
        this.getNonStrict = function (path) {
            var e_1, _a;
            try {
                for (var _b = __values(_this.xsdWorkers.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var xsdWorker = _c.value;
                    if (xsdWorker.xsd.nonStrictPath && path.includes(xsdWorker.xsd.path))
                        return xsdWorker;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        this.getIncludedXsdWorkersWithoutReference = function () {
            var firstTag = SimpleParser_1.SimpleParser.getFirstTag(_this.editor.getModel());
            return Array.from(_this.xsdWorkers.values()).filter(function (xsdWorker) {
                return _this.filterIncludedXsdWorkersWithNoReference(xsdWorker, firstTag);
            });
        };
        this.filterIncludedXsdWorkersWithNoReference = function (xsdWorker, firstTag) {
            var _a;
            return xsdWorker.xsd.alwaysInclude ||
                (firstTag && ((_a = xsdWorker.xsd.includeIfRootTag) === null || _a === void 0 ? void 0 : _a.includes(firstTag)));
        };
        this.xsdWorkers = new Map();
        this.editor = editor;
        // const worker = new XsdWorker()
        // worker.ctx.postMessage({ num: 4 })
        // worker.ctx.onmessage = (e: MessageEvent<any>) => {
        //     console.log('xsdManager: ', e.data)
        // }
    }
    return XsdManager;
}());
exports.default = XsdManager;
//# sourceMappingURL=XsdManager.js.map