"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XsdNamespaces = void 0;
var SimpleParser_1 = require("./SimpleParser");
var XsdNamespaces = /** @class */ (function () {
    function XsdNamespaces() {
    }
    XsdNamespaces.getXsdNamespaces = function (model) {
        var text = typeof model == 'string' ? model : SimpleParser_1.SimpleParser.getFullText(model);
        var namespaces = XsdNamespaces.getNamespaces(text);
        var namespaceSchemaLocations = XsdNamespaces.getNamespacesSchemaLocations(text);
        return XsdNamespaces.matchNamespacesAndNamespaceSchemaLocations(namespaces, namespaceSchemaLocations);
    };
    XsdNamespaces.getNamespaces = function (text) {
        var namespaceMap = new Map();
        XsdNamespaces.getNamespacesFromText(text).forEach(function (match) {
            var part = match.split('="');
            namespaceMap.set(part[1], part[0]);
        });
        XsdNamespaces.getNoNamespacesFromText(text).forEach(function (match) {
            namespaceMap.set(match, '');
        });
        return namespaceMap;
    };
    XsdNamespaces.getNamespacesFromText = function (text) {
        return SimpleParser_1.SimpleParser.getMatchesForRegex(text, /(?<=xmlns:)(?!xsi|html)[^:\s|/>]+="[^\s|>]+(?=")/g);
    };
    XsdNamespaces.getNoNamespacesFromText = function (text) {
        return SimpleParser_1.SimpleParser.getMatchesForRegex(text, /(?<=xmlns=")[^\s|>]+(?=")/g);
    };
    XsdNamespaces.getNamespacesSchemaLocations = function (text) {
        var namespaceSchemaLocationsMap = new Map();
        XsdNamespaces.getNamespacesSchemaLocationsFromText(text).forEach(function (match) {
            var matches = match.split(/\s+/);
            matches.forEach(function (location, index) {
                if (index % 2)
                    namespaceSchemaLocationsMap.set(location, matches[index - 1]);
            });
        });
        XsdNamespaces.getNoNamespacesSchemaLocationsFromText(text).forEach(function (match) {
            return namespaceSchemaLocationsMap.set(match, 'file://' + match);
        });
        return namespaceSchemaLocationsMap;
    };
    XsdNamespaces.getNamespacesSchemaLocationsFromText = function (text) {
        return SimpleParser_1.SimpleParser.getMatchesForRegex(text, /(?<=(xsi:schemaLocation=\n?\s*"))[^"|>]+(?=")/g);
    };
    XsdNamespaces.getNoNamespacesSchemaLocationsFromText = function (text) {
        return SimpleParser_1.SimpleParser.getMatchesForRegex(text, /(?<=(xsi:noNamespaceSchemaLocation=\n?\s*"))[^"|>]+(?=")/g);
    };
    XsdNamespaces.matchNamespacesAndNamespaceSchemaLocations = function (namespaces, namespaceSchemaLocations) {
        var e_1, _a;
        var matchedNamespacesAndNamespaceSchemaLocations = new Map();
        try {
            for (var _b = __values(namespaceSchemaLocations.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), path = _d[0], uri = _d[1];
                matchedNamespacesAndNamespaceSchemaLocations.set(uri, {
                    prefix: namespaces.get(uri),
                    path: path,
                });
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return matchedNamespacesAndNamespaceSchemaLocations;
    };
    XsdNamespaces.getXsdWorkersForNamespace = function (namespaces, xsdManager) {
        var e_2, _a;
        var xsdWorkers = [];
        try {
            for (var _b = __values(namespaces.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), namespace = _d[0], namespaceInfo = _d[1];
                if (xsdManager.has(namespaceInfo.path) || namespace === undefined || namespace === '') {
                    var xsdWorker = xsdManager.get(namespaceInfo.path);
                    if (xsdWorker)
                        xsdWorkers.push(xsdWorker.withNamespace(namespaceInfo.prefix));
                }
                else {
                    var xsdWorker = xsdManager.getNonStrict(namespaceInfo.path);
                    if (xsdWorker)
                        xsdWorkers.push(xsdWorker.withNamespace(namespaceInfo.prefix));
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        var xsdWorkersWithoutReference = xsdManager.getIncludedXsdWorkersWithoutReference();
        xsdWorkersWithoutReference.forEach(function (xsdWorker) {
            if (!xsdWorkers.includes(xsdWorker))
                xsdWorkers.push(xsdWorker);
        });
        return xsdWorkers;
    };
    return XsdNamespaces;
}());
exports.XsdNamespaces = XsdNamespaces;
//# sourceMappingURL=XsdNamespaces.js.map