"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var xpath = __importStar(require("xpath"));
var xmldom_1 = require("xmldom");
var XsdParser = /** @class */ (function () {
    function XsdParser(xsd) {
        var _a;
        var _this = this;
        var _b;
        this.getRootElements = function () {
            return _this.parseElements(_this.select("/" + _this.namespace + ":schema/" + _this.namespace + ":element", _this.xsdDom));
        };
        this.getSubElements = function (elementName) {
            var elements = _this.parseElements(_this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(elementName) + "']//" + _this.namespace + ":element", _this.xsdDom));
            var groupElements = _this.parseElements(_this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(elementName) + "']//" + _this.namespace + ":group", _this.xsdDom));
            groupElements.forEach(function (groupElement) {
                elements = elements.concat(_this.getElementsFromGroup(groupElement));
            });
            var anyElement = _this.parseElements(_this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(elementName) + "']//" + _this.namespace + ":any", _this.xsdDom));
            if (anyElement.length) {
                var rootElements = _this.getRootElements();
                rootElements.forEach(function (rootElement) {
                    elements.push(rootElement);
                });
            }
            return elements;
        };
        this.getElementsFromGroup = function (groupElement) {
            var elements = _this.parseElements(_this.select("//" + _this.namespace + ":group[@name='" + groupElement.ref + "']//" + _this.namespace + ":element", _this.xsdDom));
            var groupElements = _this.parseElements(_this.select("//" + _this.namespace + ":group[@name='" + groupElement.ref + "']//" + _this.namespace + ":group", _this.xsdDom));
            groupElements.forEach(function (groupElement) {
                elements = elements.concat(_this.getElementsFromGroup(groupElement));
            });
            return elements;
        };
        this.getFirstSubElements = function (elementName, withAttributes) {
            var elements = [];
            var complexType = _this.getComplexType(elementName);
            if (!complexType) {
                return [];
            }
            var rootElements = _this.getElementsInRootOfNode(complexType);
            if (rootElements.length > 0)
                elements.push(rootElements);
            var choices = _this.getFirstChoiceElementInNode(complexType);
            if (choices.length > 0)
                elements.push(choices.flat());
            var sequences = _this.getSequencesInNode(complexType);
            if (sequences.length > 0) {
                var sequenceElements = _this.getElementsInSequences(sequences);
                if (sequenceElements.length > 0)
                    elements.push(sequenceElements.flat());
                var sequenceChoices = _this.getFirstChoiceElementInSequences(sequences);
                if (sequenceChoices)
                    elements.push(sequenceChoices.flat());
            }
            var parsedElements = _this.parseElements(elements.flat());
            if (withAttributes)
                parsedElements = _this.addRequiredAttributesToElements(parsedElements);
            return parsedElements;
        };
        this.getComplexType = function (name) {
            return _this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(name) + "']", _this.xsdDom)[0];
        };
        this.getElementsInRootOfNode = function (node) {
            return _this.select(_this.namespace + ":element", node);
        };
        this.getFirstChoiceElementInNode = function (node) {
            return _this.select(_this.namespace + ":choice/" + _this.namespace + ":element[1]", node);
        };
        this.getSequencesInNode = function (node) {
            return _this.select(_this.namespace + ":sequence", node);
        };
        this.getElementsInSequences = function (sequences) {
            return sequences.map(function (sequence) { return _this.select(_this.namespace + ":element", sequence); });
        };
        this.getFirstChoiceElementInSequences = function (sequences) {
            return sequences.map(function (sequence) { return _this.getFirstChoiceElementInNode(sequence); }).flat();
        };
        this.addRequiredAttributesToElements = function (elements) {
            return elements.map(function (element) {
                var requiredAttribute = _this.parseAttributes(_this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(element.name) + "']/" + _this.namespace + ":attribute[@use='required']", _this.xsdDom));
                if (requiredAttribute)
                    element['requiredAttribute'] = requiredAttribute;
                return element;
            });
        };
        this.getAttributesForElement = function (elementName) {
            var attributes = _this.parseAttributes(_this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(elementName) + "']/" + _this.namespace + ":attribute", _this.xsdDom));
            var attributeGroups = _this.parseAttributes(_this.select("//" + _this.namespace + ":complexType[@name='" + _this.getElementType(elementName) + "']/" + _this.namespace + ":attributeGroup", _this.xsdDom));
            attributeGroups.forEach(function (attributeGroup) {
                attributes = attributes.concat(_this.getAttributesFromAttributeGroup(attributeGroup));
            });
            return attributes;
        };
        this.getAttributesFromAttributeGroup = function (attributeGroup) {
            var attributes = _this.parseAttributes(_this.select("//" + _this.namespace + ":attributeGroup[@name='" + attributeGroup.ref + "']/" + _this.namespace + ":attribute", _this.xsdDom));
            var attributeGroups = _this.parseAttributes(_this.select("//" + _this.namespace + ":attributeGroup[@name='" + attributeGroup.ref + "']/" + _this.namespace + ":attributeGroup", _this.xsdDom));
            attributeGroups.forEach(function (attributeGroup) {
                attributes = attributes.concat(_this.getAttributesFromAttributeGroup(attributeGroup));
            });
            return attributes;
        };
        this.parseElements = function (elements) {
            return elements.map(function (element) { return (__assign(__assign({}, _this.getAttributesForNode(element)), _this.getDocumentationForNode(element))); });
        };
        this.getAttributesForNode = function (node) {
            return _this.select('@*', node).reduce(function (acc, curr) {
                var _a;
                return (__assign(__assign({}, acc), (_a = {}, _a[curr.name] = curr.value, _a)));
            }, {});
        };
        this.getElementType = function (elementName) {
            return _this.select("//" + _this.namespace + ":element[@name='" + elementName + "']/@type", _this.xsdDom).map(function (type) { return type.value; })[0];
        };
        this.parseAttributes = function (attributes) {
            return attributes.map(function (attribute) { return (__assign(__assign({}, _this.getAttributesForNode(attribute)), _this.getDocumentationForNode(attribute))); });
        };
        this.getDocumentationForNode = function (attribute) {
            var documentationString = _this.select(_this.namespace + ":annotation/" + _this.namespace + ":documentation", attribute)
                .map(function (documentation) { return documentation.firstChild ? documentation.firstChild.data : ''; })
                .join('<br/><hr/><br/>');
            return {
                documentation: documentationString + "<br/>Source: " + _this.xsd.path,
            };
        };
        this.xsd = xsd;
        this.xsdDom = new xmldom_1.DOMParser().parseFromString(this.xsd.value);
        this.namespace = (_b = this.xsd.namespace) !== null && _b !== void 0 ? _b : 'xsd';
        this.select = xpath.useNamespaces((_a = {},
            _a[this.namespace] = 'http://www.w3.org/2001/XMLSchema',
            _a));
    }
    return XsdParser;
}());
exports.default = XsdParser;
//# sourceMappingURL=XsdParser.js.map