"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XsdWorker = void 0;
var CodeSuggester_1 = __importDefault(require("./CodeSuggester"));
var types_1 = require("./types");
var XsdParser_1 = __importDefault(require("./XsdParser"));
var XsdWorker = /** @class */ (function () {
    function XsdWorker(xsd) {
        var _this = this;
        this.withNamespace = function (namespace) {
            _this.namespace = namespace;
            return _this;
        };
        this.doCompletion = function (completionType, parentTag) {
            switch (completionType) {
                case types_1.CompletionType.snippet:
                    return _this.codeSuggester.elements(parentTag, _this.namespace, true);
                case types_1.CompletionType.element:
                    return _this.codeSuggester.elements(parentTag, _this.namespace);
                case types_1.CompletionType.attribute:
                    return _this.codeSuggester.attributes(parentTag);
                case types_1.CompletionType.incompleteElement:
                    return _this.codeSuggester.elements(parentTag, _this.namespace, false, true);
                case types_1.CompletionType.incompleteAttribute:
                    return _this.codeSuggester.attributes(parentTag, true);
            }
            return [];
        };
        this.getFirstSubElements = function (parentTag, withAttributes) {
            return _this.xsdParser.getFirstSubElements(parentTag, withAttributes);
        };
        this.xsd = xsd;
        this.xsdParser = new XsdParser_1.default(this.xsd);
        this.codeSuggester = new CodeSuggester_1.default(this.xsdParser);
    }
    return XsdWorker;
}());
exports.XsdWorker = XsdWorker;
//# sourceMappingURL=XsdWorker.js.map